<?php
class ConfigManager {
    var $configFile;
    var $configFileName;
    var $configFileDir;
    var $error;
    function ConfigManager($configFileName) {
	$this->error = FALSE;
	$this->configFileDir = "../conf/";
	$this->configFileName = $configFileName;
	return $this->loadConfigData();
    }
    
    function loadConfigData() {
	if (!$this->configFileName) return FALSE;
	unset($this->configFile);
	$fp = @fopen($this->configFileDir.$this->configFileName, "r");
	
	if (!$fp) {
	    $this->error = "Could not open file";
	    return FALSE;
	}
	
	while (!feof($fp)) {
	    $line = rtrim(fgets($fp));
	    if (!$line) continue;
	    $this->configFile[] = $line;
	}
	if (is_array($this->configFile) && count($this->configFile) > 0) {
	    return TRUE;
	} else {
	    return FALSE;
	}
    }

    function getAttributes() {
	if (!is_array($this->configFile)) return FALSE;
	for ($i = 0; $i < count($this->configFile); $i++) {
	    if ($this->configFile[$i] == "/** NO_CONFIG_BELOW **/") {
		break;
	    }
	    if (preg_match("/^(define)/", $this->configFile[$i])) {
		$l = explode('", "', $this->configFile[$i]);
		$a = explode('"', $l[0]);
		$attrib = $a[1];
		$v = explode('"', $l[1]);
		$value = $v[0];
		$ret[$attrib] = $value;
	    }
	}
	return $ret;
    }
    
    function setAttribute($attribute, $value) {
	if (!is_array($this->configFile)) return FALSE;
	for ($i = 0; $i < count($this->configFile); $i++) {
	    if (preg_match("/^(define\(\"$attribute)/", 
			   $this->configFile[$i])) {
		$this->configFile[$i] = "define(\"$attribute\", \"$value\");";
	    }
	}
    }

    function writeConfig($backup = TRUE) {
	if ($backup) {
	    copy($this->configFileDir . $this->configFileName,
		 $this->configFileDir . $this->configFileName . ".bak");
	}
	$fp = fopen($this->configFileDir.$this->configFileName, "w+");
	if (!$fp) {
	    $this->error = "Could not open " . 
		$this->configFileDir.$this->configFileName . "\n";
	    return FALSE;
	}
	for ($i = 0; is_array($this->configFile) && 
		 $i < count($this->configFile); $i++) {
	    fwrite($fp, $this->configFile[$i] . "\n");
	}
	fclose($fp);
	return TRUE;
    }
}
?>