<?php
//$Id: UMA-pgsql.inc.php,v 1.21 2003/05/31 05:47:54 rampart Exp $
/**
 *
 * Uma Classes
 *
 * Copyright (C) 2002 Vance Consulting LLC
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created By PHP Developers at:
 * http://www.vanceconsulting.net/
 * webmaster@vanceconsulting.net
 *
 * Uma SourceForge Site: http://uma.sourceforge.net/
 *
 * Description:
 * Postgresql implementation of UMA. Completely different from
 * the original MySQL version and is not interchangeable.
 */
require("config-pgsql.php");
class UMA {
    var $defaultConnectStr;
    var $dateString;
    var $error;
    var $dbLink;
    
    function UMA() {
	$this->error = '';
	$this->dateString = "Y-m-d H:i:s T";
	$this->defaultConnectStr = "user=" . DS_USER . " dbname=" . DS_NAME;
	if (DS_PASSWD) $defaultConnectStr .= " password=" . DS_PASSWORD;
    }
    
    function connect($str = FALSE) {
	if ($str) {
	    $connectionStr = $str; 
	} else {
	    $connectionStr = $this->defaultConnectStr;
	}
	$this->dbLink = pg_connect($connectionStr);
	return $this->dbLink;
    }
    
    function query($sql) {
	//echo $sql . "<br>\n";
	$this->result = pg_query($this->dbLink, $sql);
	return $this->result;
    }

    function fetch($dataType = FALSE) {
	switch ($dataType) {
	case 'array':
	    return pg_fetch_array($this->result);
	    break;
	default:
	    return pg_fetch_object($this->result);
	    break;
	}
    }
    
    function grantServiceAccess($service, $username, $permission = 1) {
	$sql = "INSERT INTO uma_client_service_permission" .
	    " (username, service, permission)" . 
	    " VALUES('$username', '$service', '$permission')";
	$db = $this->connect();
	$result = @pg_query($sql);
	return $result;
    }
    
    function removeServiceAccess($service, $username) {
	$sql = "DELETE FROM uma_client_service_permission" .
	    " WHERE username = '$username' AND service = '$service'";
	$db = $this->connect();
	$result = @pg_query($sql);
	return $result;
    }
    
    function loadUserServices() {
	$_SESSION[UMA_SESSION][$service]['permission'] = $permissionLevel;
    }
    
    function userExists($username) {
	$db = $this->connect();
	$sql = "SELECT id FROM uma_client WHERE username='$username'";
	$result = pg_query($sql);
	list($id) = pg_fetch_row($result);
	return $id;
    }
    
    function userEmailExists($email) {
	$db = $this->connect();
	$sql = "SELECT id FROM uma_client WHERE email='$email'";
	$result = pg_query($sql);
	list($id) = pg_fetch_row($result);
	return $id;
    }
    
    function sendmail($params, $stripslashes = FALSE) {
	if (!is_array($params) || !$params["To"]) {
	    return FALSE;
	}
	$headers = "From: " . $params["From"] . "\n";
	$headers .= "Reply-To: " . $params["Reply-To"] . "\n";
	$headers .= "Return-Path: <" . $params["Return-Path"] . ">\n";
	if ($stripslashes) {
	    $params['Message'] = stripslashes($params['Message']);
	    $params['Subject'] = stripslashes($params['Subject']);
	}
	return(mail($params["To"], $params["Subject"], 
		    $params["Message"], $headers,          
		    "-f " . $params["From"]));	
    }

    function testConfiguration() {
	$db = $this->connect();
	if ($result = pg_query("SELECT COUNT(*) FROM uma_client")) {
	    return TRUE;
	} else {
	    return FALSE;
	}
    }

    function deleteUser($username) {
	if (!$username) return TRUE;
	$sql = "DELETE FROM uma_client WHERE username='$username'";
	$db = $this->connect();
	if ($result = pg_query($sql)) {
	    return TRUE;
	} else {
	    $this->error = pg_last_error();
	    return FALSE;
	}	
    }

    function addUser($u) {
	$user = new User();
	$user->set('username', $u['username']);
	$user->set('firstname', $u['firstname']);
	$user->set('lastname', $u['lastname']);
	$user->set('address1', $u['address1']);
	$user->set('address2', $u['address2']);
	$user->set('city', $u['city']);
	$user->set('region', $u['region']);
	$user->set('country', $u['country']);
	$user->set('zip', $u['zip']);
	$user->set('phone1', $u['phone1']);
	$user->set('phone2', $u['phone2']);
	$user->set('mobilephone', $u['mobilephone']);
	$user->set('fax', $u['fax']);
	$user->set('email', $u['email']);
	$user->set('url', $u['url']);
	$user->set('password', $u['password']);
	$user->set('status', 'Active');
	if (!$u['challenge']) $u['challenge'] = 'No challenge';
	$user->set('challenge', $u['challenge']);
	$user->set('challenge_answer', $u['challenge_answer']);
	$sql = "INSERT INTO uma_client (username, firstname, lastname, " .
	    " address1, address2, city, region, country, zip, phone1, " . 
	    " phone2, mobilephone, fax, email, url, password, status, " .
	    " created_date, challenge, challenge_answer, notes)" .
	    " VALUES ('" . $user->get('username') . "', " .
	    "'" . $user->get('firstname') . "', '" . 
	    $user->get('lastname') . "', '" .
	    $user->get('address1') . "', '" . $user->get('address2') . "', '" .
	    $user->get('city') . "', '" . $user->get('region') . "', '" . 
	    $user->get('country') . "', '" . $user->get('zip') . "', '" . 
	    $user->get('phone1') . "', '" . $user->get('phone2') . "', '" . 
	    $user->get('mobilephone') . "', '" . $user->get('fax') . "', '" . 
	    $user->get('email') . "', '" . $user->get('url') . "', ".
	    "'" . $user->get('password') . "', 'Active', '" . 
	    date($this->dateString) . "', '" . $user->get('challenge') . 
	    "', '" . $user->get('challenge_answer') . 
	    "', '" . $user->get('notes') . "')";
	$db = $this->connect();
	if ($result = pg_query($sql)) {
	    return TRUE;
	} else {
	    $this->error = pg_last_error();
	    return FALSE;
	}
    }
    
    function getAllChallenges() {
	$db = $this->connect();
	$sql = "SELECT * FROM uma_challenge";
	$result = pg_query($sql);
	while ($objectData = pg_fetch_object($result)) {
	    $ret[] = $this->loadObject($objectData, new challenge());
	}
	return $ret;
    }

    function resetUserPermission($username) {
	$db = $this->connect();
	$sql = "DELETE FROM uma_client_service_permission" .
	    " WHERE username='$username'";
	pg_query($sql);
    }
    
    function setUserPerm($username, $service, $perm) {
	$db = $this->connect();
	$sql = "SELECT COUNT(*) FROM uma_client_service_permission" .
	    " WHERE username='$username' AND service='$service'";
	$result = pg_query($sql);
	list($recordExists) = pg_fetch_row($result, 0);
	if (!$recordExists) {
	    $sql = "INSERT INTO uma_client_service_permission" .
		" (username, service, permission)" .
		" VALUES('$username', '$service', '$perm')";
	} else {
	    $sql = "UPDATE uma_client_service_permission" . 
		" SET permission = '$perm' WHERE username='$username'" .
		" AND service='$service'";
	}
	//echo $sql;
	if ($result = pg_query($sql)) {
	    return TRUE;
	} else {
	    $this->error = pg_last_error();
	    return FALSE;
	}
       
    }
    
    function removeSlashes($object) {
	if (!is_object($object)) return FALSE;
	$vars = get_object_vars($object);
	foreach ($vars as $attribute=>$val) {
	    $vars->$attribute = stripslashes($val);
	}
	return $vars;
    }
    
    function getAllUsers() {
	$db = $this->connect();
	$sql = "SELECT * FROM uma_client ORDER BY username";
	$result = pg_query($sql);
	while ($object = pg_fetch_object($result)) {
	    $ret[] = $this->loadObject($object, new user());
	}
	return $ret;
    }
    
    function getAllServices($user = FALSE) {
	$db = $this->connect();
	if ($user) {
	    $sql = "SELECT service, permission FROM" .
		" uma_client_service_permission WHERE username='$user'";
	} else {
	    $sql = "SELECT service FROM uma_client_service";
	}
	//echo $sql;
	$result = pg_query($db, $sql);
	while ($row = pg_fetch_array($result)) {
	    $ret[] = new service($row['service']);
	    $ret[count($ret) - 1]->set('permission', $row['permission']);
	}
	//print_r($ret);
	//echo "<br>";
	return $ret;
    }

    function getService($service) {
	if (!$service) {
	    return FALSE;
	}
	$db = $this->connect();
	$sql = "SELECT * FROM uma_client_service WHERE service='$service'";
	//echo $sql;
	$result = pg_query($db, $sql);
	//echo $result;
	$objectData = pg_fetch_object($result);
	return $this->loadObject($objectData, new service());
    }
    
    function getUser($username) {
	$db = $this->connect();
	$sql = "SELECT * FROM uma_client WHERE username='$username'";
	$result = pg_query($sql);
	$objectData = pg_fetch_object($result);
	return $this->loadObject($objectData, new user());
    }
    
    function loadObject($objectData, $object) {
	$data = get_object_vars($objectData);
	//print_r($data);
	if (!is_array($data)) return FALSE;
	foreach ($data as $attrib=>$val) {
	    $object->$attrib = $val;
	}
	//print_r($object);
	return $object;
    }
    
    function saveUser($userData) {
	$sql = "UPDATE uma_client set ";
	$first = TRUE;
	foreach ($userData as $key=>$value) {
	    if ($key == 'password_conf' || 
		$key == 'current_username') continue;
	    if ($first) {
		$first = FALSE;
	    } else {
		$sql .= ", ";
	    }
	    $sql .= "$key='$value'";
	}
	$sql .= " WHERE username='" . $userData['current_username'] . "'";
	$db = $this->connect();
	if ($result = pg_query($sql)) {
	    return TRUE;
	} else {
	    $this->error = pg_last_error();
	    return FALSE;
	}
    }

    function saveService($serviceData) {
	if (!is_array($serviceData)) {
	    $uma->error = "saveService takes a hash.";
	    return FALSE;
	}
	$sql = "UPDATE uma_client_service set ";
	$first = TRUE;
	foreach ($serviceData as $key=>$value) {
	    if ($key == 'oldservice') continue;
	    if ($first) {
		$first = FALSE;
	    } else {
		$sql .= ", ";
	    }
	    $sql .= "$key='$value'";
	}
	$sql .= " WHERE service='" . $serviceData['oldservice'] . "'";
	$db = $this->connect();
	//echo $sql;
	if ($result = pg_query($sql)) {
	    return TRUE;
	} else {
	    $this->error = pg_last_error();
	    return FALSE;
	}
    }
    
    function serviceExists($service) {
	$sql = "SELECT id FROM uma_client_service WHERE service = '$service'";
	$db = $this->connect();
	$result = pg_query($sql);
	return pg_num_rows($result);
    }

    function addService($serviceData) {
	$service = new service();
	$service->set('service', $serviceData['service']);
	$service->set('description', $serviceData['description']);
	$sql = "INSERT INTO uma_client_service (service, description)".
	    " VALUES ('" . $service->get('service') . "', '" .
	    $service->get('description') . "')";
	$db = $this->connect();
	if (!$result = @pg_query($sql)) {
	    $this->error = pg_last_error();
	    return FALSE;
	} else {
	    return TRUE;
	}
	
    }

    function toHash($object) {
	$vars = get_object_vars($object);
	if (!is_array($vars)) return FALSE;
	foreach ($vars as $attrib=>$val) {
	    $ret[$attrib] = $val;
	}
	return $ret;
    }
    


    function authenticateUser($username, $password, $service, $permission) {
	$connectStr = "user=" . DS_USER . " dbname=" . DS_NAME;
	if (DS_PASSWD) $connectStr .= " password=" . DS_PASSWORD;
	///echo $connectStr;
	$db = UMA::connect($connectStr);
	$sql = "SELECT COUNT(*) FROM uma_client WHERE username='$username'" .
	    " AND password = '$password'";
	//echo $sql;
	$result = pg_query($db, $sql);
	list($validUsernameAndPassword) = pg_fetch_array($result, 
							 0, PGSQL_NUM);
	if ($validUsernameAndPassword != 1) return FALSE;
	
	$sql = "SELECT COUNT(*) FROM uma_client_service_permission" .
	    " WHERE service = '$service' AND username='$username'" .
	    " AND permission >= '$permission'";
	$result = pg_query($db, $sql);
	list($validAccessToService) = pg_fetch_array($result, 
						     0, PGSQL_NUM);
	if ($validAccessToService != 1) return FALSE;
	return TRUE;
    }
    
    /**
     * Generates a new password.
     *
     * @author Keith Vance (keith@vanceconsulting.net) 2.14.03
     **/
    function makeNewPassword() {
	$constants = array('b', 'c', 'd', 'f', 'g', 'h', 'j',
			   'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 
			   'v', 'w', 'x', 'y', 'z');
	$vowels = array('a', 'e', 'i', 'o', 'u');
	
	for ($i = 0; $i < 8; $i++) {
	    if ($i == substr(time(), -1) || $i == substr(time(), -2)) {
		srand(time());
	        $pass .= $vowels[rand(0, count($vowels))];
	    } else {
		$pass .= $constants[rand(0, count($constants))];
	    }
	}
	return $pass;
    }
}

class mObject {
    function get($attribute) {
	if (STRIP_SLASHES_GET) {
	    return stripslashes($this->$attribute);
	} else {
	    return $this->$attribute;
	}
    }

    function set($attribute, $value) {
	if (ADD_SLASHES_SET) {
	    $this->$attribute = addslashes($value);
	} else {
	    $this->$attribute = $value;
	}
    }
}

class user extends mObject {
    function user($username = FALSE) {
	if ($username) {
	    $uma = new UMA();
	    $db = $uma->connect();
	    $sql = "SELECT * FROM uma_client WHERE username='$username'";
	    $result = pg_query($sql);
	    $objectData = pg_fetch_object($result);
	    $this = $uma->loadObject($objectData, new user());
	}
    }
    
    function loadSessionPermissions() {
	if (!$this->getUsername()) {
	    return FALSE;
	}
	
	$uma = new UMA();
	$services = $this->getServices();
	//print_r($services);
	$_SESSION[UMA_SESSION]['services'] = FALSE;
	foreach ($services as $service=>$permission) {
	    $_SESSION[UMA_SESSION]['services'][$service] = $permission;
	}
    }
    
    function getServices() {
	if (!$this->getUsername()) {
	    return FALSE;
	}
	$uma = new UMA();
	$db = $uma->connect();
	$sql = "SELECT service, permission FROM" .
	    " uma_client_service_permission" .
	    " WHERE username='" . $this->getUsername() . "'";
	$result = pg_query($db, $sql);
	$i = 0;
	while ($row = pg_fetch_array($result)) {
	    $ret[$row['service']] = $row['permission'];
	    $i++;
	}
	return $ret;
    }
    
    function getId() {
	return $this->get('id');
    }
    
    function getPassword() {
	return $this->get('password');
    }
    
    function getUsername() {
	return $this->get('username');
    }
    
    function getFirstname() {
	return $this->get('firstname');
    }

    function getLastname() {
	return $this->get('lastname');
    }

    function getAddress1() {
	return $this->get('address1');
    }

    function getAddress2() {
	return $this->get('address2');
    }
    
    function getCity() {
	return $this->get('city');
    }
    
    function getRegion() {
	return $this->get('region');
    }

    function getCountry() {
	return $this->get('country');
    }
    
    function getZip() {
	return $this->get('zip');
    }

    function getPhone1() {
	return $this->get('phone1');
    }

    function getPhone2() {
	return $this->get('phone2');
    }

    function getMobilePhone() {
	return $this->get('mobilephone');
    }

    function getFax() {
	return $this->get('fax');
    }

    function getEmail() {
	return $this->get('email');
    }

    function getUrl() {
	return $this->get('url');
    }
    
    function getStatus() {
	return $this->get('status');
    }

    function getCreatedDate() {
	return $this->get('created_date');
    }

    function getLastLoginDate() {
	return $this->get('last_login_date');
    }

    function getLastLoginIP() {
	return $this->get('last_login_ip');
    }

    function getLastFailedLoginIP() {
	return $this->get('last_failed_login_ip');
    }

    function getChallenge() {
	return $this->get('challenge');
    }

    function getChallengeAnswer() {
	return $this->get('challenge_answer');
    }

    function getNotes() {
	return $this->get('notes');
    }
}

class challenge extends mObject {

}

class service extends mObject {
    function service($service = FALSE) {
	if ($service) {
	    $uma = new UMA();
	    $db = $uma->connect();
	    $sql = "SELECT * FROM uma_client_service" .
		" WHERE service='$service'";
	    $result = pg_query($sql);
	    $objectData = pg_fetch_object($result);
	    $this = $uma->loadObject($objectData, new service());
	}
    }
    
    function getGroups($noAccessGroups = FALSE) {
	if (!$this->getName()) {
	    return FALSE;
	}
	$uma = new UMA();
	$db = $uma->connect();
	if (!$noAccessGroups) {
	    $sql = "SELECT client_group FROM uma_client_group_service_access" .
		" WHERE service = '" . $this->getName() . "'";
	} else {
	    $sql = "SELECT client_group FROM uma_client_group" .
		" WHERE client_group NOT IN (SELECT client_group FROM" .
		" uma_client_group_service_access WHERE service = '" . 
		$this->getName() . "')";
	}
	$result = pg_query($sql);
	while ($row = pg_fetch_array($result)) {
	    $ret[] = new group($row['client_group']);
	}
	return $ret;
    }
    
    function getUsers($noAccessUsers = FALSE) {
	if (!$this->getName()) {
	    return FALSE;
	}
	$uma = new UMA();
	$db = $uma->connect();
	if (!$noAccessUsers) {
	    $sql = "SELECT username FROM uma_client_service_permission" .
		" WHERE username NOT IN (SELECT DISTINCT(a.username)" .
		" FROM uma_client_group_member a," . 
		" uma_client_group_service_access b" . 
		" WHERE a.client_group = b.client_group" . 
		" AND b.service = '" . $this->getName() . "')" . 
		" AND service = '" . $this->getName() . "'";
	} else {
	    $sql = "SELECT username FROM uma_client WHERE" . 
		" username NOT IN (SELECT username FROM" .
		" uma_client_service_permission" .
		" WHERE service = '" . $this->getName() . "') AND" .
		" username NOT IN (SELECT DISTINCT(a.username)" .
		" FROM uma_client_group_member a," . 
		" uma_client_group_service_access b" . 
		" WHERE a.client_group = b.client_group" . 
		" AND b.service = '" . $this->getName() . "')";
	    //echo $sql;
	}
	$result = pg_query($sql);
	while ($row = pg_fetch_array($result)) {
	    $ret[] = new user($row['username']);
	}
	return $ret;
    }
    
    function getName() {
	return $this->get('service');
    }
    
    function getDescription() {
	return $this->get('description');
    }
    
    function getAdminUrl() {
	return $this->get('admin_url');
    }
    
    function getStatus() {
	return $this->get('status');
    }
    
    function getAdminSortOrder() {
	return $this->get('admin_sort_order');
    }
    
    function adminModule() {
	if ($this->get('admin_module') == 'Yes') {
	    return TRUE;
	} else {
	    return FALSE;
	}
    }
}
require("Utils.class.php");
?>
