<?php
//$Id: Utils.class.php,v 1.2 2003/02/20 23:49:04 rampart Exp $
/**
* Utils class is a junk drawer class where I put various methods that print
* commonly used chunks of HTML and other junk that doesn't fit nicely 
* into it's own class.
* Created By Keith Vance
**/
class Utils {
    /**
     * Redirects browser to another page maintaining the SESSION id
     * in the URL if necessary.
     * @author Keith Vance <keith@vanceconsulting.net> 12.4.2002
     */
    function redirect($url, $sessid = FALSE, $full = FALSE) {
	if ($sessid && !eregi('PHPSESSID', $url)) {
	    $url .= Utils::addSESSID($url, $sessid);
	}

	if ($full) {
	    $url = "http://" . $_SERVER['HTTP_HOST'] . $url;
	}

	//	echo $url;
	header("location:$url");
	exit;
    }

    /**
     * This method "cleans" a url. Currently it cleans a url
     * of the PHPSESSID. Removing the PHPSESSID is handy when
     * allowing a user to email someone the url that they are 
     * visiting. I don't like the idea of sending someone someone
     * else's PHPSESSID. 
     *
     * @author Keith Vance <keith@vanceconsulting.net> 12.10.2002
     * @access public
     * @param String url - the url that needs some cleaning.
    */
    function cleanURL($url) {
	return preg_replace("/\?*PHPSESSID=\w*&*/i", "", $url);
    }
    
    /**
     * This method adds the PHPSESSID to the supplied URL.
     *
     * @author Keith Vance <keith@vanceconsulting.net> 12.10.2002
     * @access public
     * @param String $url - the string getting the PHPSESSID
     */
    function addSESSID($url, $sessid) {
	if (preg_match("/\?/", $url)) {
	    $sep = "&";
	} else {
	    $sep = "?";
	}
	return $sep.$sessid;
    }
    
    /**
     * Validate email address
     * Created by: Keith Vance(keith@vanceconsulting.net)
     * Created On: 3.23.02
     */
    function checkEmail($address) {
	return eregi("^([-!#\$%&'*+./0-9=?A-Z^_`a-z{|}~])+@([-!#\$%&'*+/0-9=?A-Z^_`a-z{|}~]+\\.)+[a-zA-Z]{2,4}\$", $address);
    }
	
    /**
     * Method: PrintStateOption
     * Purpose: prints all the regions in a <option> tags.
     *	This method also ends the <select> tag.
     *	$selected is the region to default to in the <select> menu.
     * Created By Keith Vance
     **/
    function printRegionOptions ($selected = FALSE, $endSelect = TRUE) {
	if ($selected) {
	    print("<OPTION SELECTED value=\"$selected\">$selected</option>\n");
	}
	print("<OPTION VALUE=\"Alabama\">Alabama</option>\n");
	print("<OPTION VALUE=\"Alaska\">Alaska</option>\n");
	print("<OPTION VALUE=\"Arizona\">Arizona</option>\n");
	print("<OPTION VALUE=\"Arkansas\">Arkansas</option>\n");
	print("<OPTION VALUE=\"California\">California</option>\n");
	print("<OPTION VALUE=\"Colorado\">Colorado</option>\n");
	print("<OPTION VALUE=\"Connecticut\">Connecticut</option>\n");
	print("<OPTION VALUE=\"Delaware\">Delaware</option>\n");
	print("<OPTION VALUE=\"District of Columbia\">District of Columbia</option>\n");
	print("<OPTION VALUE=\"Florida\">Florida</option>\n");
	print("<OPTION VALUE=\"Georgia\">Georgia</option>\n");
	print("<OPTION VALUE=\"Hawaii\">Hawaii</option>\n");
	print("<OPTION VALUE=\"Idaho\">Idaho</option>\n");
	print("<OPTION VALUE=\"Illinois\">Illinois</option>\n");
	print("<OPTION VALUE=\"Indiana\">Indiana</option>\n");
	print("<OPTION VALUE=\"Iowa\">Iowa</option>\n");
	print("<OPTION VALUE=\"Kansas\">Kansas</option>\n");
	print("<OPTION VALUE=\"Kentucky\">Kentucky</option>\n");
	print("<OPTION VALUE=\"Louisiana\">Louisiana</option>\n");
	print("<OPTION VALUE=\"Maine\">Maine</option>\n");
	print("<OPTION VALUE=\"Maryland\">Maryland</option>\n");
	print("<OPTION VALUE=\"Massachusetts\">Massachusetts</option>\n");
	print("<OPTION VALUE=\"Michigan\">Michigan</option>\n");
	print("<OPTION VALUE=\"Minnesota\">Minnesota</option>\n");
	print("<OPTION VALUE=\"Mississippi\">Mississippi</option>\n");
	print("<OPTION VALUE=\"Missouri\">Missouri</option>\n");
	print("<OPTION VALUE=\"Montana\">Montana</option>\n");
	print("<OPTION VALUE=\"Nebraska\">Nebraska</option>\n");
	print("<OPTION VALUE=\"Nevada\">Nevada</option>\n");
	print("<OPTION VALUE=\"New Hampshire\">New Hampshire</option>\n");
	print("<OPTION VALUE=\"New Jersey\">New Jersey</option>\n");
	print("<OPTION VALUE=\"New Mexico\">New Mexico</option>\n");
	print("<OPTION VALUE=\"New York\">New York</option>\n");
	print("<OPTION VALUE=\"North Carolina\">North Carolina</option>\n");
	print("<OPTION VALUE=\"North Dakota\">North Dakota</option>\n");
	print("<OPTION VALUE=\"Ohio\">Ohio</option>\n");
	print("<OPTION VALUE=\"Oklahoma\">Oklahoma</option>\n");
	print("<OPTION VALUE=\"Oregon\">Oregon</option>\n");
	print("<OPTION VALUE=\"Pennsylvania\">Pennsylvania</option>\n");
	print("<OPTION VALUE=\"Rhode Island\">Rhode Island</option>\n");
	print("<OPTION VALUE=\"South Carolina\">South Carolina</option>\n");
	print("<OPTION VALUE=\"South Dakota\">South Dakota</option>\n");
	print("<OPTION VALUE=\"Tennessee\">Tennessee</option>\n");
	print("<OPTION VALUE=\"Texas\">Texas</option>\n");
	print("<OPTION VALUE=\"Utah\">Utah</option>\n");
	print("<OPTION VALUE=\"Vermont\">Vermont</option>\n");
	print("<OPTION VALUE=\"Virginia\">Virginia</option>\n");
	print("<OPTION VALUE=\"Washington\">Washington</option>\n");
	print("<OPTION VALUE=\"West Virginia\">West Virginia</option>\n");
	print("<OPTION VALUE=\"Wisconsin\">Wisconsin</option>\n");
	print("<OPTION VALUE=\"Wyoming\">Wyoming</option>\n");
	print("<OPTION VALUE=\"Other\">Other</option>\n");
	if ($endSelect) print("</select>\n");
    } // end PrintStateOption method
	
    /**
     * Method: PrintCountryOption
     * Purpose: Prints a list of <option> tags for all the countries that I am aware of.
     *			This method also ends the <select> tag.
     * Created By Keith Vance
     **/
    function printCountryOptions() {
	print("<option value=\"AF\">Afghanistan</option>\n");
	print("<option value=\"AL\">Albania</option>\n");
	print("<option value=\"DZ\">Algeria</option>\n");
	print("<option value=\"AS\">American Samoa</option>\n");
	print("<option value=\"AD\">Andorra</option>\n");
	print("<option value=\"AO\">Angola</option>\n");
	print("<option value=\"AI\">Anguilla</option>\n");
	print("<option value=\"AQ\">Antarctica</option>\n");
	print("<option value=\"AG\">Antigua And Barbuda</option>\n");
	print("<option value=\"AR\">Argentina</option>\n");
	print("<option value=\"AM\">Armenia</option>\n");
	print("<option value=\"AW\">Aruba</option>\n");
	print("<option value=\"AU\">Australia</option>\n");
	print("<option value=\"AT\">Austria</option>\n");
	print("<option value=\"AZ\">Azerbaijan</option>\n");
	print("<option value=\"BS\">Bahamas, The</option>\n");
	print("<option value=\"BH\">Bahrain</option>\n");
	print("<option value=\"BD\">Bangladesh</option>\n");
	print("<option value=\"BB\">Barbados</option>\n");
	print("<option value=\"BY\">Belarus</option>\n");
	print("<option value=\"BE\">Belgium</option>\n");
	print("<option value=\"BZ\">Belize</option>\n");
	print("<option value=\"BJ\">Benin</option>\n");
	print("<option value=\"BM\">Bermuda</option>\n");
	print("<option value=\"BT\">Bhutan</option>\n");
	print("<option value=\"BO\">Bolivia</option>\n");
	print("<option value=\"BA\">Bosnia and Herzegovina</option>\n");
	print("<option value=\"BW\">Botswana</option>\n");
	print("<option value=\"BV\">Bouvet Island</option>\n");
	print("<option value=\"BR\">Brazil</option>\n");
	print("<option value=\"IO\">British Indian Ocean Territory</option>\n");
	print("<option value=\"BN\">Brunei</option>\n");
	print("<option value=\"BG\">Bulgaria</option>\n");
	print("<option value=\"BF\">Burkina Faso</option>\n");
	print("<option value=\"BI\">Burundi</option>\n");
	print("<option value=\"KH\">Cambodia</option>\n");
	print("<option value=\"CM\">Cameroon</option>\n");
	print("<option value=\"CA\">Canada</option>\n");
	print("<option value=\"CV\">Cape Verde</option>\n");
	print("<option value=\"KY\">Cayman Islands</option>\n");
	print("<option value=\"CF\">Central African Republic</option>\n");
	print("<option value=\"TD\">Chad</option>\n");
	print("<option value=\"CL\">Chile</option>\n");
	print("<option value=\"CN\">China</option>\n");
	print("<option value=\"HK\">China (Hong Kong S.A.R.)</option>\n");
	print("<option value=\"MO\">China (Macau S.A.R.)</option>\n");
	print("<option value=\"CX\">Christmas Island</option>\n");
	print("<option value=\"CC\">Cocos (Keeling) Islands</option>\n");
	print("<option value=\"CO\">Colombia</option>\n");
	print("<option value=\"KM\">Comoros</option>\n");
	print("<option value=\"CG\">Congo</option>\n");
	print("<option value=\"CD\">Congo, Democractic Republic of the  </option>\n");
	print("<option value=\"CK\">Cook Islands</option>\n");
	print("<option value=\"CR\">Costa Rica</option>\n");
	print("<option value=\"CI\">Cote D\"Ivoire (Ivory Coast)</option>\n");
	print("<option value=\"HR\">Croatia (Hrvatska)</option>\n");
	print("<option value=\"CU\">Cuba</option>\n");
	print("<option value=\"CY\">Cyprus</option>\n");
	print("<option value=\"CZ\">Czech Republic</option>\n");
	print("<option value=\"DK\">Denmark</option>\n");
	print("<option value=\"DJ\">Djibouti</option>\n");
	print("<option value=\"DM\">Dominica</option>\n");
	print("<option value=\"DO\">Dominican Republic</option>\n");
	print("<option value=\"TP\">East Timor</option>\n");
	print("<option value=\"EC\">Ecuador</option>\n");
	print("<option value=\"EG\">Egypt</option>\n");
	print("<option value=\"SV\">El Salvador</option>\n");
	print("<option value=\"GQ\">Equatorial Guinea</option>\n");
	print("<option value=\"ER\">Eritrea</option>\n");
	print("<option value=\"EE\">Estonia</option>\n");
	print("<option value=\"ET\">Ethiopia</option>\n");
	print("<option value=\"FK\">Falkland Islands (Islas Malvinas)</option>\n");
	print("<option value=\"FO\">Faroe Islands</option>\n");
	print("<option value=\"FJ\">Fiji Islands</option>\n");
	print("<option value=\"FI\">Finland</option>\n");
	print("<option value=\"FR\">France</option>\n");
	print("<option value=\"GF\">French Guiana</option>\n");
	print("<option value=\"PF\">French Polynesia</option>\n");
	print("<option value=\"TF\">French Southern Territories</option>\n");
	print("<option value=\"GA\">Gabon</option>\n");
	print("<option value=\"GM\">Gambia, The</option>\n");
	print("<option value=\"GE\">Georgia</option>\n");
	print("<option value=\"DE\">Germany</option>\n");
	print("<option value=\"GH\">Ghana</option>\n");
	print("<option value=\"GI\">Gibraltar</option>\n");
	print("<option value=\"GR\">Greece</option>\n");
	print("<option value=\"GL\">Greenland</option>\n");
	print("<option value=\"GD\">Grenada</option>\n");
	print("<option value=\"GP\">Guadeloupe</option>\n");
	print("<option value=\"GU\">Guam</option>\n");
	print("<option value=\"GT\">Guatemala</option>\n");
	print("<option value=\"GN\">Guinea</option>\n");
	print("<option value=\"GW\">Guinea-Bissau</option>\n");
	print("<option value=\"GY\">Guyana</option>\n");
	print("<option value=\"HT\">Haiti</option>\n");
	print("<option value=\"HM\">Heard and McDonald Islands</option>\n");
	print("<option value=\"HN\">Honduras</option>\n");
	print("<option value=\"HU\">Hungary</option>\n");
	print("<option value=\"IS\">Iceland</option>\n");
	print("<option value=\"IN\">India</option>\n");
	print("<option value=\"ID\">Indonesia</option>\n");
	print("<option value=\"IR\">Iran</option>\n");
	print("<option value=\"IQ\">Iraq</option>\n");
	print("<option value=\"IE\">Ireland</option>\n");
	print("<option value=\"IL\">Israel</option>\n");
	print("<option value=\"IT\">Italy</option>\n");
	print("<option value=\"JM\">Jamaica</option>\n");
	print("<option value=\"JP\">Japan</option>\n");
	print("<option value=\"JO\">Jordan</option>\n");
	print("<option value=\"KZ\">Kazakhstan</option>\n");
	print("<option value=\"KE\">Kenya</option>\n");
	print("<option value=\"KI\">Kiribati</option>\n");
	print("<option value=\"KR\">Korea</option>\n");
	print("<option value=\"KP\">Korea, North </option>\n");
	print("<option value=\"KW\">Kuwait</option>\n");
	print("<option value=\"KG\">Kyrgyzstan</option>\n");
	print("<option value=\"LA\">Laos</option>\n");
	print("<option value=\"LV\">Latvia</option>\n");
	print("<option value=\"LB\">Lebanon</option>\n");
	print("<option value=\"LS\">Lesotho</option>\n");
	print("<option value=\"LR\">Liberia</option>\n");
	print("<option value=\"LY\">Libya</option>\n");
	print("<option value=\"LI\">Liechtenstein</option>\n");
	print("<option value=\"LT\">Lithuania</option>\n");
	print("<option value=\"LU\">Luxembourg</option>\n");
	print("<option value=\"MK\">Macedonia, Former Yugoslav Republic of</option>\n");
	print("<option value=\"MG\">Madagascar</option>\n");
	print("<option value=\"MW\">Malawi</option>\n");
	print("<option value=\"MY\">Malaysia</option>\n");
	print("<option value=\"MV\">Maldives</option>\n");
	print("<option value=\"ML\">Mali</option>\n");
	print("<option value=\"MT\">Malta</option>\n");
	print("<option value=\"MH\">Marshall Islands</option>\n");
	print("<option value=\"MQ\">Martinique</option>\n");
	print("<option value=\"MR\">Mauritania</option>\n");
	print("<option value=\"MU\">Mauritius</option>\n");
	print("<option value=\"YT\">Mayotte</option>\n");
	print("<option value=\"MX\">Mexico</option>\n");
	print("<option value=\"FM\">Micronesia</option>\n");
	print("<option value=\"MD\">Moldova</option>\n");
	print("<option value=\"MC\">Monaco</option>\n");
	print("<option value=\"MN\">Mongolia</option>\n");
	print("<option value=\"MS\">Montserrat</option>\n");
	print("<option value=\"MA\">Morocco</option>\n");
	print("<option value=\"MZ\">Mozambique</option>\n");
	print("<option value=\"MM\">Myanmar</option>\n");
	print("<option value=\"NA\">Namibia</option>\n");
	print("<option value=\"NR\">Nauru</option>\n");
	print("<option value=\"NP\">Nepal</option>\n");
	print("<option value=\"AN\">Netherlands Antilles</option>\n");
	print("<option value=\"NL\">Netherlands, The</option>\n");
	print("<option value=\"NC\">New Caledonia</option>\n");
	print("<option value=\"NZ\">New Zealand</option>\n");
	print("<option value=\"NI\">Nicaragua</option>\n");
	print("<option value=\"NE\">Niger</option>\n");
	print("<option value=\"NG\">Nigeria</option>\n");
	print("<option value=\"NU\">Niue</option>\n");
	print("<option value=\"NF\">Norfolk Island</option>\n");
	print("<option value=\"MP\">Northern Mariana Islands</option>\n");
	print("<option value=\"NO\">Norway</option>\n");
	print("<option value=\"OM\">Oman</option>\n");
	print("<option value=\"PK\">Pakistan</option>\n");
	print("<option value=\"PW\">Palau</option>\n");
	print("<option value=\"PA\">Panama</option>\n");
	print("<option value=\"PG\">Papua new Guinea</option>\n");
	print("<option value=\"PY\">Paraguay</option>\n");
	print("<option value=\"PE\">Peru</option>\n");
	print("<option value=\"PH\">Philippines</option>\n");
	print("<option value=\"PN\">Pitcairn Island</option>\n");
	print("<option value=\"PL\">Poland</option>\n");
	print("<option value=\"PT\">Portugal</option>\n");
	print("<option value=\"PR\">Puerto Rico</option>\n");
	print("<option value=\"QA\">Qatar</option>\n");
	print("<option value=\"RE\">Reunion</option>\n");
	print("<option value=\"RO\">Romania</option>\n");
	print("<option value=\"RU\">Russia</option>\n");
	print("<option value=\"RW\">Rwanda</option>\n");
	print("<option value=\"SH\">Saint Helena</option>\n");
	print("<option value=\"KN\">Saint Kitts And Nevis</option>\n");
	print("<option value=\"LC\">Saint Lucia</option>\n");
	print("<option value=\"PM\">Saint Pierre and Miquelon</option>\n");
	print("<option value=\"VC\">Saint Vincent And The Grenadines</option>\n");
	print("<option value=\"WS\">Samoa</option>\n");
	print("<option value=\"SM\">San Marino</option>\n");
	print("<option value=\"ST\">Sao Tome and Principe</option>\n");
	print("<option value=\"SA\">Saudi Arabia</option>\n");
	print("<option value=\"SN\">Senegal</option>\n");
	print("<option value=\"SC\">Seychelles</option>\n");
	print("<option value=\"SL\">Sierra Leone</option>\n");
	print("<option value=\"SG\">Singapore</option>\n");
	print("<option value=\"SK\">Slovakia</option>\n");
	print("<option value=\"SI\">Slovenia</option>\n");
	print("<option value=\"SB\">Solomon Islands</option>\n");
	print("<option value=\"SO\">Somalia</option>\n");
	print("<option value=\"ZA\">South Africa</option>\n");
	print("<option value=\"GS\">South Georgia And The South Sandwich Islands</option>\n");
	print("<option value=\"ES\">Spain</option>\n");
	print("<option value=\"LK\">Sri Lanka</option>\n");
	print("<option value=\"SD\">Sudan</option>\n");
	print("<option value=\"SR\">Suriname</option>\n");
	print("<option value=\"SJ\">Svalbard And Jan Mayen Islands</option>\n");
	print("<option value=\"SZ\">Swaziland</option>\n");
	print("<option value=\"SE\">Sweden</option>\n");
	print("<option value=\"CH\">Switzerland</option>\n");
	print("<option value=\"SY\">Syria</option>\n");
	print("<option value=\"TW\">Taiwan</option>\n");
	print("<option value=\"TJ\">Tajikistan</option>\n");
	print("<option value=\"TZ\">Tanzania</option>\n");
	print("<option value=\"TH\">Thailand</option>\n");
	print("<option value=\"TG\">Togo</option>\n");
	print("<option value=\"TK\">Tokelau</option>\n");
	print("<option value=\"TO\">Tonga</option>\n");
	print("<option value=\"TT\">Trinidad And Tobago</option>\n");
	print("<option value=\"TN\">Tunisia</option>\n");
	print("<option value=\"TR\">Turkey</option>\n");
	print("<option value=\"TM\">Turkmenistan</option>\n");
	print("<option value=\"TC\">Turks And Caicos Islands</option>\n");
	print("<option value=\"TV\">Tuvalu</option>\n");
	print("<option value=\"UG\">Uganda</option>\n");
	print("<option value=\"UA\">Ukraine</option>\n");
	print("<option value=\"AE\">United Arab Emirates</option>\n");
	print("<option value=\"UK\">United Kingdom</option>\n");
	print("<option value=\"US\" selected>United States</option>\n");
	print("<option value=\"UM\">United States Minor Outlying Islands</option>\n");
	print("<option value=\"UY\">Uruguay</option>\n");
	print("<option value=\"UZ\">Uzbekistan</option>\n");
	print("<option value=\"VU\">Vanuatu</option>\n");
	print("<option value=\"VA\">Vatican City State (Holy See)</option>\n");
	print("<option value=\"VE\">Venezuela</option>\n");
	print("<option value=\"VN\">Vietnam</option>\n");
	print("<option value=\"VG\">Virgin Islands (British)</option>\n");
	print("<option value=\"VI\">Virgin Islands (US)</option>\n");
	print("<option value=\"WF\">Wallis And Futuna Islands</option>\n");
	print("<option value=\"EH\">Western Sahara</option>\n");
	print("<option value=\"YE\">Yemen</option>\n");
	print("<option value=\"YU\">Yugoslavia</option>\n");
	print("<option value=\"ZM\">Zambia</option>\n");
	print("<option value=\"ZW\">Zimbabwe</option>\n");
	print("</select>\n");
    } // End PrintCountryOption
    
    /**
     * Method: NumberOptions
     * Purpose: Prints a list of <option> tags which contain numbers.
     *			This method also ends the <select> tag.
     * Parameters: $num - the number of numbers you want in the <option> tag
     *			   $selected - the number you want to be selected as the default.
     * Created By Keith Vance
     **/
    function NumberOptions ($num, $selected) {
	for ($i = 0; $i <= $num; $i++) {
	    if ($i == $selected ) {
		print("<option selected value=$i>$i</option>\n");
	    } else {
		print("<option value=$i>$i</option>\n");
	    }
	}
	print("</select>\n");
    } // end NumberOptions

    function NumberRangeOptions ($start, $finish, $selected) {
	for ($i = $start; $i <= $finish; $i++) {
	    if ($i == $selected) {
		print("<option selected value=\"$i\">$i</option>\n");
	    } else {
		print("<option value=\"$i\">$i</option>\n");
	    }
	}
    }

    function MonthOptions ($selected = FALSE) {
	if ($selected != 1) {
	    print("<option value=\"1\">January</option>\n");
	} else {
	    print("<option value=\"1\" selected>January</option>\n");
	}
	
	if ($selected != 2) {
	    print("<option value=\"2\">February</option>\n");
	} else {
	    print("<option value=\"2\" selected>February</option>\n");
	}
	
	if ($selected != 3) {
	    print("<option value=\"3\">March</option>\n");
	} else {
	    print("<option value=\"3\" selected>March</option>\n");
	}
	
	if ($selected != 4) {
	    print("<option value=\"4\">April</option>\n");
	} else {
	    print("<option value=\"4\" selected>April</option>\n");
	}

	if ($selected != 5) {
	    print("<option value=\"5\">May</option>\n");
	} else {
	    print("<option value=\"5\" selected>May</option>\n");
	}

	if ($selected != 6) {
	    print("<option value=\"6\">June</option>\n");
	} else {
	    print("<option value=\"6\" selected>June</option>\n");
	}

	if ($selected != 7) {
	    print("<option value=\"7\">July</option>\n");
	} else {
	    print("<option value=\"7\" selected>July</option>\n");
	}

	if ($selected != 8) {
	    print("<option value=\"8\">August</option>\n");
	} else {
	    print("<option value=\"8\" selected>August</option>\n");
	}

	if ($selected != 9) {
	    print("<option value=\"9\">September</option>\n");
	} else {
	    print("<option value=\"9\" selected>September</option>\n");
	}

	if ($selected != 10) {
	    print("<option value=\"10\">October</option>\n");
	} else {
	    print("<option value=\"10\" selected>October</option>\n");
	}

	if ($selected != 11) {
	    print("<option value=\"11\">November</option>\n");
	} else {
	    print("<option value=\"11\" selected>November</option>\n");
	}

	if ($selected != 12) {
	    print("<option value=\"12\">December</option>\n");
	} else {
	    print("<option value=\"12\" selected>December</option>\n");
	}
    }
    /**
     * Method: YesNoOptions
     * Purpose: Prints a list of <option> tags which contain Y or N.
     *			This method also ends the <select> tag.
     * Parameters: $selected - either Y or N, whichever you want to be the default
     * Created By Keith Vance
     **/
    function YesNoOptions ($selected) {
	if ($selected == "Y" ) {
	    print("<option selected value=Y>Y</option>\n");
	    print("<option value=N>N</option>\n");
	} elseif ($selected == "N" ) {
	    print("<option value=Y>Y</option>\n");
	    print("<option selected value=N>N</option>\n");
	}
	print("</select>\n");
    } // end YesNoOption

    /**
      * Method: YesNoRadio
      * Purpose: Prints radio buttons for Yes or No. 
      * Parameters: $name - the name you want to call the <input>
      *	   $selected - either Y or N, whichever you want to be the default
      * Created By Keith Vance
      **/
    function YesNoRadio ($name, $selected) {
	if ($selected == "Y" ) {
	    print("<input type=\"radio\" name=\"$name\" value=\"Y\" checked class=\"radio\"><span class=\"bodytext\">Yes</span>\n");
	    print("<input type=\"radio\" name=\"$name\" value=\"No\" class=\"radio\"><span class=\"bodytext\">No</span>\n");
	} elseif ($selected == "N" ) {
	    print("<input type=\"radio\" name=\"$name\" value=\"Y\" class=\"radio\"><span class=\"bodytext\">Yes</span>\n");
	    print("<input type=\"radio\" name=\"$name\" value=\"N\" checked class=\"radio\"><span class=\"bodytext\">No</span>\n");
	}
	print("</select>\n");
    }
}
?>