drop table uma_challenge cascade;
drop table uma_client cascade;
drop table uma_client_service cascade;
drop table uma_client_service_permission cascade;
drop table uma_service_entity cascade;
--
-- Table structure for table challenge (formerly known as Passphrase)
--
CREATE TABLE uma_challenge (
  id serial,
  challenge character varying(100) not null unique,
  PRIMARY KEY(challenge)
);

INSERT INTO uma_challenge (challenge) VALUES ('What is your high school name?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your pet\'s name?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your spouse\'s middle name?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your favorite sport to play?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your mother\'s maiden name?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your father\'s middle name?');
INSERT INTO uma_challenge (challenge) VALUES ('What is your favorite sport to watch?');
INSERT INTO uma_challenge (challenge) VALUES ('No challenge');

--
-- Table structure for table 'service'
--
CREATE TABLE uma_client_service (
  id serial,
  service character varying(35) not null unique,
  description text,
  admin_url character varying(100),
  status character varying(20) default 'Active',
  admin_sort_order int2,
  admin_module character varying(4) default 'Yes',
  PRIMARY KEY(service)
);
INSERT INTO uma_client_service (service, description) VALUES('Uma','Uma Authentication Service');

--
-- Table structure for table 'client'
--
CREATE TABLE uma_client (
  id serial,
  username character varying(32) not null unique,
  firstname character varying(25) default NULL,
  lastname character varying(25) default NULL,
  address1 character varying(65) default NULL,
  address2 character varying(65) default NULL,
  city character varying(25) default NULL,
  region character varying(30) default NULL,
  country character varying(30) default NULL,
  zip character varying(15) default NULL,
  phone1 character varying(20) default NULL,
  phone2 character varying(20) default NULL,
  mobilephone character varying(20) default NULL,
  fax character varying(20) default NULL,
  email character varying(65) default NULL,
  url character varying(65) default NULL,
  password character varying(32) default NULL,
  status character varying(20),
  created_date timestamp with time zone,
  last_login_date timestamp with time zone,
  last_login_IP inet,
  last_failed_login_IP inet,
  challenge character varying(100) default 'No challenge',
  challenge_answer character varying(100),
  notes text,
  PRIMARY KEY (username),
  FOREIGN KEY (challenge) REFERENCES uma_challenge ON UPDATE CASCADE 
	ON DELETE CASCADE
);

CREATE TABLE uma_client_service_permission (
  id serial,
  service character varying(35) not null
	REFERENCES uma_client_service ON UPDATE CASCADE ON DELETE CASCADE,
  username character varying(32) not null
	REFERENCES uma_client ON UPDATE CASCADE ON DELETE CASCADE,
  permission integer not null default 0,
  PRIMARY KEY (service, username)
);

CREATE TABLE uma_service_entity (
  id serial,
  service character varying(35) not null
	REFERENCES uma_client_service ON UPDATE CASCADE,
  entity OID,
  locked char(1) default 'N'
);