#!/usr/local/bin/php -q
<?php
/**
 * This is UMA's configuration management tool.
 * You should use this to manage UMA's configuration files located in
 * the conf directory.
 * 
 * This software is provided as is and without any warrantee. It is your
 * responsibility to backup your files and maintain a secure system.
 * 
 * Author: Keith Vance <keith@vanceconsulting.net>
 * Version: 1.0
 * Requires: ktools package of PHP utilities.
 *           PHP CGI installed in /usr/local/bin
 */
ini_set('include_path', rtrim(@current(file('mepath.php'))));
require("Utils.class.php");
require("ConfigManager.inc.php");
require("ktools/kutil.php");
require("ktools/kio.php");
$databases[1] = "pgsql";
$databases[2] = "mysql";
kbanner("UMA Configuration Tool\n Version 1.0\n");
kstdout("1. PostgreSQL\n");
kstdout("2. MySQL (Not Yet Implemented)\n");
kstdout("Select database 1 or 2 [1]: ");
$databaseType = kstdin();
if (!$databaseType) $databaseType = 1;
$cfman = new ConfigManager("config-" . $databases[$databaseType] . ".php");

if ($cfman->error) {
    kstdout("\nERROR: I couldn't open the configuration file (" . $cfman->configFileDir.$cfman->configFileName . ").\n\nTIPS:\nDid you move the file from the conf directory or move the conf directory?\n\nYou need to cd into tools directory for umaconfig.php to run properly.\nIf you are trying to run this from another directory cd\nto the tools directory and execute ./umaconfig.php \n");
    kstdout("\nThe commercial version of the UMA Administrator provides\nonline administration of the configuration files.\nIt is available for purchase at http://neverwillbes.com/uma/\n\n\n");
    exit;
}
$attributes = $cfman->getAttributes();
kmenu($attributes);
kstdout("Enter the name of attribute you wish to modified: ");
$attributeToChange = kstdin();
$attribs = array_keys($attributes);
if (!in_array($attributeToChange, $attribs)) {
    kstdout("ERROR: " . $attributeToChange . " is NOT a valid attribute.\nRe-run umaconfig.php and enter a valid attribute.\nAttributes are case-sensative.\n\n");
    exit;
}
kstdout("Enter the new value for $attributeToChange: ");
$newValue = kstdin();
$cfman->setAttribute($attributeToChange, $newValue);
$cfman->writeConfig();
kstdout("\nConfiguration saved!\n\nHere's the new configuration settings.\n\n");
$attributes = $cfman->getAttributes();
kmenu($attributes);
?>